<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>18.1.3: <TT>unsigned</TT> integers</title>
<link href="sx4ba.html" rev=precedes>
<link href="sx4da.html" rel=precedes>
<link href="sx4a.html" rev=subdocument>
</head>
<body>
<H3>18.1.3: <TT>unsigned</TT> integers</H3>

<p>For
each of the integral types,
there is a corresponding <TT>unsigned</TT> type.
Thus, we have <TT>unsigned char</TT>,
<TT>unsigned short int</TT>,
<TT>unsigned int</TT>,
and
<TT>unsigned long int</TT>.
There are two differences between the <TT>unsigned</TT> types
and the default, signed types:
<OL><li>They do not hold negative numbers;
their range is from 0 up to some maximum.
<li>They have guaranteed properties on overflow.
If the range of <TT>unsigned int</TT> on some machine is 0-65,535,
and if an <TT>unsigned int</TT> variable contains the value 65,535,
then adding 1 to it will wrap around to 0.
Whenever a calculation involving <TT>unsigned</TT> integers overflows,
or tries to go negative,
the result is the remainder that would be obtained if the true
(mathematical)
result were divided by the range of the <TT>unsigned</TT> type.
In other words,
if <TT>UINT_MAX</TT> is the largest value
that will fit in an <TT>unsigned int</TT>
(that is, if the range is 0-<TT>UINT_MAX</TT>),
then the results of calculations that would overflow,
such as
<pre>
	65535 + 1
and
	5 - 10
</pre>
are actually
<pre>
	(65535 + 1) % (UINT_MAX+1)
and
	(5 - 10) % (UINT_MAX+1)
</pre>

</OL>
</p><p>The guaranteed minimum ranges of the unsigned types are:
<br>
<br>
<pre>
	<TT>unsigned char</TT>	0 - 255
	<TT>unsigned short int</TT>	0 - 65535
	<TT>unsigned int</TT>	0 - 65535
	<TT>unsigned long int</TT>	0 - 4294967295
</pre>
</p><p>These multiword type names can also be abbreviated.
Instead of writing <TT>long int</TT>, you can write <TT>long</TT>.
Instead of writing <TT>short int</TT>, you can write <TT>short</TT>.
Instead of writing <TT>unsigned int</TT>,
you can write <TT>unsigned</TT>.
Instead of writing <TT>unsigned long int</TT>,
you can write <TT>unsigned long</TT>.
Instead of writing <TT>unsigned short int</TT>,
you can write <TT>unsigned short</TT>.
</p><p>In the absence of the <TT>unsigned</TT> keyword,
types
<TT>short int</TT>, <TT>int</TT>, and <TT>long int</TT>
are all signed.
However, depending on the particular compiler you're using,
plain type <TT>char</TT> might be signed or unsigned.
If you need an explicitly signed character type,
you can use <TT>signed char</TT>.

</p><hr>
<p>
Read sequentially:
<a href="sx4ba.html" rev=precedes>prev</a>
<a href="sx4da.html" rel=precedes>next</a>
<a href="sx4a.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1996-1999
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
